// This may look like C code, but it is really -*- C++ -*-
//
// this class definition is for use with large systems (very long integer)
// most significant bits ly in vlint[max] ??
//
// history:
// - 1st version Apr02 
// ToDo:
//

#ifndef __cplusplus
#error "We need c++ here!"
#endif

#ifndef B2size
#error B2size must be defined here as number of ints holding basecfg
#endif
// use together with: typedef class vlint tbase1

#ifndef _Vlint_h
#ifdef __GNUG__
/* #pragma interface */
#endif
#define _Vlint_h 1

class vlint      /* very long int */
{
public:

  unsigned int    a[B2size];

// public:

//                vlint(const vlint& y); // ???
                  vlint(int y=0);  // int cast to vlint?

                  ~vlint();

// vlint&         operator =  (const vlint& y);  // predefined
// vlint&         operator =  (const int& y);    // implicite: =(vlint)y
   vlint&         operator ^= (const vlint& y);
   vlint&         operator |= (const vlint& y);
   vlint&         operator &= (const vlint& y);
   vlint&         operator >>= (const int& y);
   vlint&         operator <<= (const int& y);

//   vlint&         operator - (const vlint& x, const vlint& y);
// vlint&         operator ^ (const vlint& x, const vlint& y);
// vlint&         operator | (const vlint& x, const vlint& y);
// vlint&         operator & (const vlint& x, const vlint& y);

// vlint&         operator >> (const vlint& x, int& y); 
// vlint&         operator << (const vlint& x, int& y); 
// bool&          operator >= (const vlint& x, const vlint& y); 
// bool&          operator <= (const vlint& x, const vlint& y); 
// bool&          operator == (const vlint& x, const vlint& y); 
// bool&          operator <  (const vlint& x, const vlint& y); 

                  /* ToDo: check for a[1..B2size]==0 */
//                  operator int() const {
// int t=0; for(int i=1;i<B2size;i++) t|=a[i];
// if (t) { printf("error: tbase_value to big, can not be casted to int\n"); }
//                   return a[0]; }
// leads to ambiguous results: ToDo: only for explixit casts?
//  ex:  vlint ^ int == int(vlint) ^ int == vlint ^ vlint(int)

 operator int() { return a[0]; } // 2014-12-17 cast operator to get low bits

};

// function

inline void pout(const vlint& x){
  int i; for(i=0;i<B2size;i++) printf(" %08x",x.a[B2size-i-1]);
  printf("\n");
}


// inline members

// inline vlint::vlint(const vlint& y) :a(y.a) {} // ???
inline vlint::vlint(const int y) { // add const 2016
//  a[0]=y; for (int i=1;i<B2size;i++) a[i]=0;
  int i; a[0]=y; for (i=1;i<B2size;i++) a[i]=0;
}

inline vlint::~vlint() {}

// cast-op. is similar to constructor!
// inline vlint::operator int() const { return a[0]; }

// inline vlint&  vlint::operator =  (const vlint& y) 
// { int i; for(i=0;i<B2size;i++) a[i] = y.a[i]; return *this; } 


inline vlint&  vlint::operator ^= (const vlint& y){
 for(int i=0;i<B2size;i++) a[i]^=y.a[i];
 return *this;
}

inline vlint&  vlint::operator |= (const vlint& y){
 int i; for(i=0;i<B2size;i++) a[i]|=y.a[i];
 return *this;
}

inline vlint&  vlint::operator &= (const vlint& y){
 for(int i=0;i<B2size;i++) a[i]&=y.a[i];
 return *this;
}

/* y should be never greater than B2size*8*sizeof(int)! */
inline vlint&  vlint::operator >>= (const int& y){
  class vlint t;
  int i, si=y/(8*sizeof(int)), ri=y%(8*sizeof(int));
  if (si>B2size) { si=B2size; ri=0; }
  for(i=B2size-si;i<B2size;i++) t.a[i]=0;
  for(i=0   ;i<B2size-si  ;i++) t.a[i] =a[i+si  ]>>ri;
  if(ri)
  for(i=0   ;i<B2size-si-1;i++) t.a[i]|=a[i+si+1]<<(8*sizeof(int)-ri);
//  printf(">>=%d\n",y);pout(*this);pout(t);
  for(i=0;i<B2size;i++) a[i]=t.a[i];
  return *this;
}

inline vlint&  vlint::operator <<= (const int& y){
  class vlint t;
  int i, si=y/(8*sizeof(int)), ri=y%(8*sizeof(int));
  if (si>B2size) { si=B2size; ri=0; }
  for(i=0   ;i<si    ;i++) t.a[i]=0;
  for(i=si  ;i<B2size;i++) t.a[i] =a[i-si  ]<<ri;
  if(ri)
  for(i=si+1;i<B2size;i++) t.a[i]|=a[i-si-1]>>(8*sizeof(int)-ri);
//  printf("<<=%d\n",y);pout(*this);pout(t);
  for(i=0;i<B2size;i++) a[i]=t.a[i];
  return *this;
}

//  functions

inline bool operator == (const vlint& x, const vlint& y){
  for(int i=0;i<B2size;i++) if(x.a[i]!=y.a[i]) return false;
  return true; }

inline bool operator != (const vlint& x, const vlint& y){
  for(int i=0;i<B2size;i++) if(x.a[i]!=y.a[i]) return true;
  return false; }

inline bool operator < (const vlint& x, const vlint& y){
  for(int i=B2size-1;i>=0;i--){
    if(x.a[i]<y.a[i]) return true;
    if(x.a[i]>y.a[i]) return false;
  }
  return false; 
}

inline bool operator > (const vlint& x, const vlint& y){
  for(int i=B2size-1;i>=0;i--){
    if(x.a[i]<y.a[i]) return false;
    if(x.a[i]>y.a[i]) return true;
  }
  return false; 
}

/* new operator JS-2012-04, better using always <= */
inline bool operator >= (const vlint& x, const vlint& y){
  for(int i=B2size-1;i>=0;i--){
    if(x.a[i]>y.a[i]) return true;
    if(x.a[i]<y.a[i]) return false;
  }
  return true; 
}

inline bool operator <= (const vlint& x, const vlint& y){
  for(int i=B2size-1;i>=0;i--){
    if(x.a[i]<y.a[i]) return true;
    if(x.a[i]>y.a[i]) return false;
  }
  return true; 
}

/* SGIs MIPSpro Compilers CC Bug: for(int i) only once! */
inline vlint operator << (const vlint& x, const int& y){
  class vlint t= (vlint)0; /* 2015-05-17 add = 0 and remove L3+4 speed+20% */
  int i, si=y/(8*sizeof(int)), ri=y%(8*sizeof(int));
//  if (si>B2size) { return (vlint)0; }
//  for(i=0   ;i<si    ;i++) t.a[i]=0;
  for(i=si  ;i<B2size;i++) t.a[i] =x.a[i-si  ]<<ri;
  if(ri)
  for(i=si+1;i<B2size;i++) t.a[i]|=x.a[i-si-1]>>(8*sizeof(int)-ri);
  // printf("<<%d\n",y);pout(x);pout(t);
  return t;
}

// 2014-12 avoid implicite casts
inline vlint operator << (const vlint& x, const unsigned int& y){  
  return x << (int)y;
}

inline vlint operator >> (const vlint& x, const int& y){
  class vlint t=(vlint)0; /* 2015-05-17 add =0, remove L3+4 */
  int i, si=y/(8*sizeof(int)), ri=y%(8*sizeof(int));
//  if (si>B2size) { return (vlint)0; }
//  for(i=B2size-si;i<B2size;i++) t.a[i]=0;
  for(i=0   ;i<B2size-si  ;i++) t.a[i] =x.a[i+si  ]>>ri;
  if(ri)
  for(i=0   ;i<B2size-si-1;i++) t.a[i]|=x.a[i+si+1]<<(8*sizeof(int)-ri);
//  printf(">>%d\n",y);pout(x);pout(t);
  return t;
}
// ToDo: speedup by special functions getbit + setbit[s] div+mod+shift+and
// ToDo: speedup by special function for vlint |= 1to2bit_int << int; 
// ToDo: speedup by special function for int = 1to2bit_int & (vlint >> int);

inline vlint operator >> (const vlint& x, const unsigned int& y){  
  return x >> (int)y;
}

inline vlint operator ^ (const vlint& x, const vlint& y){
  class vlint t;
  for(int i=0;i<B2size;i++) t.a[i]=x.a[i]^y.a[i];
  return t;
}

inline vlint operator & (const vlint& x, const vlint& y){
  class vlint t;
  for(int i=0;i<B2size;i++) t.a[i]=x.a[i]&y.a[i];
  return t;
}

// JS 2016-01 for lNbrk
inline vlint operator & (const vlint& x, const int& y){
  class vlint t;
  t.a[0]=x.a[0]&y; for(int i=1;i<B2size;i++) t.a[i]=0;
  return t;
}

inline vlint operator & (const int& x, const vlint& y){
  class vlint t;
  t.a[0]=y.a[0] & x; for(int i=1;i<B2size;i++) t.a[i]=0;
  return t;
}

// JS 2016-01
//inline int operator & (const vlint& x, const int& y){
//  return x.a[0]&y; 
//}



// int=vlint&int may be cause bugs, it should return vlint and need
//  a cast to get int,  but its faster for low bit-testing
//  ToDo: use inline int lowbits(vlint,const int), remove int=vlint&int 2014-12
//inline int operator & (const int& x, const vlint& y){ return y.a[0]&x; }
//inline int operator & (const vlint& x, const int& y){ return x.a[0]&y; }

// fast replacement for old int=vlint&int, which may cause bugs
inline int lowbits(const vlint& x, const int y){ return x.a[0]&y; } // 2014-12

inline vlint operator - (const vlint& x, const int& y){
  class vlint t;
  unsigned int cy=0; // carry flag
  t.a[0]=x.a[0]-y; if (((unsigned int)y)>x.a[0]) cy=1;
  for(int i=1;i<B2size;i++){
   t.a[i]=x.a[i]-cy;
   cy=((x.a[i])?1:0);  // 2016-01-08 B2size>2 bug fixed
  }
//  printf("-%d\n",y);pout(x);pout(t);
//  printf("vlint.ERROR vlint-int, p.e. (vlint(1)<<70)-1 = ~(~TBASE0<<70)\n");
//  exit(1); // bad results for NN=200 (((tbase)1)<<100)-1 2016-01-07
  return t;
}

inline vlint operator | (const vlint& x, const vlint& y){
  class vlint t;
  for(int i=0;i<B2size;i++) t.a[i]=x.a[i]|y.a[i];
  return t;
}

inline vlint operator | (const vlint& x, const int& y){ // 2014-12-17
  return x | (vlint)y;
}

inline vlint  operator ~ (const vlint& x){
 class vlint t(x);
 for(int i=0;i<B2size;i++) t.a[i]=~x.a[i];
 return t;
}

inline bool  operator ! (const vlint& x){  /* if zero return true 2012-07 */
 for(int i=0;i<B2size;i++) if (x.a[i]) return false;
 return true;
}

// /* cast operator, how to define correctly? */
// inline int  operator int() (const vlint& x){
// int t=0; for(int i=1;i<B2size;i++) t|=x.a[i];
// if (t) { printf("error: tbase_value to big, can not be casted to int\n"); }
// return t|x.a[0];
//}

// 2019-03  speed up ibfly for vlint, go around shift 32,64,128,...
// funcion BFLY s<=2^5 vs s>2^5 (2^5=32), shift simu of bfly is to slow
//#define IBFLY(i2,msk,s) i2=((i2)&~((msk)|((msk)<<(s))))
//                        |((((i2)&(msk))<<(s))|(((i2)>>(s))&(msk)))
inline void ibfly( vlint& x, const vlint& msk, const int s){
  int i;
  if ((s>>5)==0) { // s<=31 (1,2,4,8,16)
#pragma GCC unroll 8 /* unroll max 8 (NN<=256) gcc8=ok ~gcc7 */
    for(i=0;i<B2size;i++) x.a[i]= ( x.a[i]&~(msk.a[i]|(msk.a[i]<<s)))
                                 |((x.a[i]&msk.a[i])<<s)
                                 |((x.a[i]>>s)&msk.a[i]);
  } else { // s>=32 (32,64,128,...)
    vlint x0=x;
//    if ((s>>5)>=B2size){printf("ERR s/32=%d bigger B2size\n",s/32); exit(1);}
//      else
#pragma GCC unroll 8 /* unroll max 8 (NN<=256) gcc8=ok ~gcc7 */
    for(i=0;i<B2size;i++) x.a[i]= (x0.a[i       ]&~(msk.a[i&~(s>>5)]))
                                 |(x0.a[i^(s>>5)]& (msk.a[i&~(s>>5)]));
  } // if else
#if 0  // DEBUG
  vlint y;
  y = (((x0)&~((msk)|((msk)<<(s))))\
                        |((((x0)&(msk))<<(s))|(((x0)>>(s))&(msk))));
  if (x != y ) {
         printf(" s=%d\n",s);
         pout(msk);
         pout(x0);
         pout(y);
         pout(x);
         exit(2);
  }
#endif
} // ibfly


#endif
